/*
 * Copyright (C) 2017 Yasushi SHOJI <yashi@atmark-techno.com>
 *
 * Configuration settings for Atmark Techno Armadillo-640
 *
 * SPDX-License-Identifier:	GPL-2.0+
 */
#ifndef __ARMADILLO640_CONFIG_H
#define __ARMADILLO640_CONFIG_H

#include "mx6_common.h"

#ifdef CONFIG_SPL
#include "imx6_spl.h"
#endif

/* cancel autoboot for maintenance mode */
#if defined(CONFIG_SUPPORT_MAINTENANCE_MODE) && !defined(__ASSEMBLY__)
int is_maintenance_mode(void);
#endif

/* Physical Memory Map */
#define CONFIG_NR_DRAM_BANKS		1
#define CONFIG_SYS_SDRAM_BASE 0x80000000

/* Size of malloc() pool */
#define CONFIG_SYS_MALLOC_LEN		(16 * SZ_1M)

#define CONFIG_ENV_SIZE			SZ_512K
#define CONFIG_ENV_OFFSET		SZ_512K

/* Memory Map */
#define CONFIG_SYS_INIT_RAM_ADDR	IRAM_BASE_ADDR
#define CONFIG_SYS_INIT_RAM_SIZE	IRAM_SIZE
#define CONFIG_SYS_INIT_SP_ADDR		(CONFIG_SYS_INIT_RAM_ADDR + CONFIG_SYS_INIT_RAM_SIZE)

/* CONFIG_MXC_UART */

#if defined CONFIG_CONSOLE_UART1
#define CONFIG_MXC_UART_BASE		UART1_BASE
#elif defined CONFIG_CONSOLE_UART3
#define CONFIG_MXC_UART_BASE		UART3_BASE
#endif

/* USB Configs */
#define CONFIG_EHCI_HCD_INIT_AFTER_RESET
#define CONFIG_MXC_USB_PORTSC  (PORT_PTS_UTMI | PORT_PTS_PTW)
#define CONFIG_MXC_USB_FLAGS   0
#define CONFIG_USB_MAX_CONTROLLER_COUNT 2

/* MMC Configs */
#define CONFIG_FSL_ESDHC
#define CONFIG_SYS_FSL_ESDHC_ADDR  USDHC1_BASE_ADDR
#define CONFIG_SYS_MMC_ENV_DEV     0

/* Ethernet */
#ifdef CONFIG_FEC_MXC
#define CONFIG_FEC_XCV_TYPE RMII
#define CONFIG_MII
#define CONFIG_FEC_MXC_PHYADDR		0
#define IMX_FEC_BASE			ENET_BASE_ADDR
#endif

#define CONFIG_BOOTCOMMAND \
	"run setup_mmcargs; ext4load mmc 0:2 ${loadaddr} /boot/uImage; ext4load mmc 0:2 0x83000000 /boot/a640.dtb; bootm ${loadaddr} - 0x83000000;"
#define CONFIG_EXTRA_ENV_SETTINGS \
	"setup_mmcargs=setenv bootargs root=/dev/mmcblk0p2 rootwait ${optargs};\0"\
	"tftpboot=tftpboot uImage; tftpboot 0x83000000 a640.dtb; bootm ${loadaddr} - 0x83000000;"


#endif
